﻿using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Toolkit.Log4
{
    public static class LogHelper
    {
        public static ConcurrentQueue<string[]> logQueue = new ConcurrentQueue<string[]>();
        private static readonly log4net.ILog debug = log4net.LogManager.GetLogger("LogFile");
        public static void Info(string info)
        {
            if (debug.IsErrorEnabled)
            {
                debug.Info(info);
                logQueue.Enqueue(new string[2] { DateTime.Now.ToString("yy-MM-dd HH:mm:ss:fff"), info });
                Console.WriteLine(info);
            }
        }
        public static readonly log4net.ILog error = log4net.LogManager.GetLogger("LogError");
        private static void Error(string info, Exception exception)
        {
            if (error.IsErrorEnabled)
            {
                error.Error(info, exception);
                Console.WriteLine(info + "__" + exception.Message);
            }
        }
    }
}
