﻿using Prism.Events;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using Toolkit.Event;
using Toolkit.Log4;

namespace Toolkit.Tcp
{
    public class TCPServer
    {

        public IPAddress iPAddress;
        private IPEndPoint endp;
        private AddressFamily addressFamily;
        private SocketType socketType;
        private ProtocolType protocolType;
        public static List<Client> clientList = new List<Client>();
        private bool isEnd = true;
        public string startstr;
        public string stopstr;
        public List<string> strmes = new List<string>();
        public Socket _socket;


        public static List<TCPServer> servers = new List<TCPServer>();

        public TCPServer()
        {
            addressFamily = AddressFamily.InterNetwork;
            socketType = SocketType.Stream;
            protocolType = ProtocolType.Tcp;
            iPAddress = IPAddress.Parse("192.168.2.111");
            endp = new IPEndPoint(iPAddress, 503);
            //startstr = server.StartStr;
            //stopstr = server.StopStr;

        }
        public static bool createState = true;//创建是否成功
        public bool Start()
        {
            try
            {
                _socket = new Socket(addressFamily, socketType, protocolType);
                _socket.Bind(endp);
                _socket.Listen(1024);
                isEnd = true;
                LogHelper.Info(iPAddress + "服务已启动，等待连接......");
                Console.WriteLine(iPAddress + "服务已启动，等待连接......");
                Thread l = new Thread(tcpCon);
                l.Name = iPAddress + "服务";
                l.Start();
                servers.Add(this);
                createState = true;
                return true;
            }
            catch (Exception ex)
            {
                createState = false;
                LogHelper.error.Error("", ex);
                return false;
            }
        }

        public void tcpCon()
        {
            
            while (isEnd)
            {
                try
                {
                    Socket clientSocket = _socket.Accept();
                    Console.WriteLine((clientSocket.RemoteEndPoint as IPEndPoint).Address + "已连接");
                    LogHelper.Info((clientSocket.RemoteEndPoint as IPEndPoint).Address + "已连接");
                    Thread thread = new Thread(new ThreadStart(()=>{

                        Client client = new Client(clientSocket, startstr, stopstr);
                        strmes = client.strmegs;
                        clientList.Add(client);

                    }));
                    thread.Start();
                }
                catch
                {
                    break;
                }
               
            }
            
        }

        public bool Stop()
        {
            try
            {
                isEnd = false;
                _socket.Close();

                foreach ( var client in clientList )//遍历已经存储的客户端
                {
                    client.clientSocket.Close();
                }
                    return true;
            }
            catch (Exception ex)
            {
                LogHelper.error.Error("", ex);
                return false;
            }
        }


        public static void BroadcastMessage(string message, Client clientSocket)//这个函数用来广播接收到的客户端消息  参数1为消息，参数2为消息来源（客户端）
        {
            var onConnectedList = new List<Client>();//用来存储已断开服务器连接的客户端

            foreach (var client in clientList)//遍历已经存储的客户端
            {
                if (clientSocket == client)//如果该客户端是消息来源，则不重复发送消息给该客户端
                {
                    continue;
                }
                if (client.Connected)//判断该客户端的状态
                {
                    client.SendMessage(client.ip + ":" + message);//
                }
                else//把已断开连接的客户端放到数组中
                {
                    onConnectedList.Add(client);
                }
            }
            foreach (var temp in onConnectedList)//广播完之后从存储已连接客户端集合中移除掉已断开连接的客户端
            {
                clientList.Remove(temp);
            }
        }

        public  static IEventAggregator eventAggregator;
        public class Client
        {
            public Socket clientSocket;
            private Thread t;
            public string ip = "";
            private byte[] data = new byte[1024];
            public List<string> strmegs = new List<string>();
            public string startstr;
            public string stopstr;
            public Client(Socket socket, string startstr, string stopstr)
            {
                clientSocket = socket;
                this.startstr = startstr;
                this.stopstr = stopstr;
                ip = (clientSocket.RemoteEndPoint as IPEndPoint).Address.ToString();//获取客户端的ip
                t = new Thread(ReceiveMessage);//开启线程执行循环接收消息
                t.Name = "tcp接收消息";
                t.Start();

            }
            private void ReceiveMessage()//接收消息
            {
                int length = 0;//初始化消息的长度
                while (true)//循环接收消息
                {
                    try
                    {

                      
                        length = clientSocket.Receive(data);//获取存放消息数据数组的长度
                        if (clientSocket.Poll(10, SelectMode.SelectRead))//？？？？
                        {
                            clientSocket.Close();
                            break;
                        }
                        if (length != 0)//判断是否有数组内是否存放消息数据
                        {
                               string str = Encoding.Unicode.GetString(data, 0, length);//Byte转为string
                                if (str.Length != 0)
                                {
                                    eventAggregator.GetEvent<TcpServerMsg>().Publish(str);
                                    //LogHelper.Info("来自" + clientSocket.RemoteEndPoint + ":" + str);
                                    Console.WriteLine("来自" + (clientSocket.RemoteEndPoint as IPEndPoint).Address + ":" + str);//输出到服务器控制台
                                    strmegs.Add(str);
                                }
                        }
                    }
                    catch(Exception e)
                    {
                       
                        for ( int i = 0; i < clientList.Count; i++ )
                        {
                            if ( !clientList[ i ].Connected ) 
                            {
                                clientList.RemoveAt(i);
                                i = 0;
                            }
                        }
                            LogHelper.Info(ip + "客户端断开");
                            Console.WriteLine(ip + "客户端断开");
                            break;
                        
                    }
                }
            }



            public void SendMessage(string message)//发送消息
            {
                byte[] data = Encoding.Unicode.GetBytes(message);
                clientSocket.Send(data);
            }
            public bool Connected//获取该客户端的状态
            {
                get { return clientSocket.Connected; }
            }
        }

    }
}
