﻿using Prism.Mvvm;
using Prism.Regions;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Media;
using Toolkit.Log4;
using Toolkit.Tcp;
using Toolkit.View;

namespace Toolkit.ViewMode
{
    public class MainWindowViewMode : BindableBase
    {

        private ObservableCollection<UserControl> items = new ObservableCollection<UserControl>();
        public ObservableCollection<UserControl> Items { get => items; set => items = value; }


        public List<ToolBase.ToolBase> ToolBases = new List<ToolBase.ToolBase>();
        public MainWindowViewMode(IRegionManager regionManager) 
        {
            

            TcpTrigger trigger = new TcpTrigger();
            Items.Add(trigger);
            ToolBases.Add((TcpTriggerViewMode)trigger.DataContext);

            TcpWrite tcpWrite= new TcpWrite();
            Items.Add(tcpWrite);
            ToolBases.Add((TcpWriteViewMode)tcpWrite.DataContext);




            Task.Run(()=> 
            {
                TcpTriggerViewMode tcpTrigger=( TcpTriggerViewMode ) ToolBases[0];
                TcpWriteViewMode  Write=( TcpWriteViewMode ) ToolBases[1];
                while (true) 
                {
                    try
                    {
                        
                        if ( tcpTrigger.SendStrs.Count != 0 && Write.client.socket.Connected)
                        {
                            Write.Tdata = tcpTrigger.SendStrs[ 0 ];
                            if ( Write.Tdata == "GetMessage" ) 
                            {
                                Write.GetMessage();
                                ToolBases[ 0 ].SendStrs.RemoveAt(0);
                                continue;
                            }
                            if ( Write.SendMsg(tcpTrigger) )
                            {
                                ToolBases[ 0 ].SendStrs.RemoveAt(0);
                               
                            }
                        }
                        if ( !Write.client.socket.Connected)
                        {
                            
                                Thread.Sleep(10);
                                tcpTrigger.TcpServerStop();
                                Write.client.socket.Close();
                                LogHelper.Info("打印机断开");
                                Write.client.Connect();
                                if ( Write.client.socket.Connected )
                                {
                                    LogHelper.Info("打印机连接成功");
                                    tcpTrigger.server.Start();
                                }
                            
                        }
                       
                    }
                    catch(Exception e) 
                    {
                       
                        LogHelper.Info(e.Message);
                        Thread.Sleep(3000);
                    }
                    Thread.Sleep(50);
                }

            });


            


           




        }
    }
}
